' 1407-White-Noise, aus dem asm-Kurs 2013
' der Ausgang ist jeder PortB.x
'
' Pseudo-Zufallszahlen = weisses Rauschen durch Simulation eines 22-Bit-
' Schieberegister mit EXOR-Rckkopplung der beiden rechten Bit.
' (alle Bit = 0 bei EXOR verboten, alle Bit = 1 bei EXNOR verboten!)
' 2^n-1 = 2^22-1 = 1 bis 4194304dez
' (mgliche Lngen = n : 2, 3, 4, 6, 7, 15, 22, 60, 63, 127, 153, 532)
' In der Literatur wird das erste Bit mit Bit1 gezhlt
' Im folgenden wird das erste Bit mit Bit0 bezeichnet
' fo=9,6MHz/2/11,5Cy ~417kHz, fu ~0,1Hz
'-------------------------------------------------------------------------------
$regfile = "attiny13.dat"
'$regfile = "attiny2313.dat"
'$regfile = "m8def.dat"

$asm
'.device Attiny13                               ' fr gavrasm
'.cseg                                          ' Codesegment
'.org 0                                         ' fr Adresse 0
Init:
        ldi r16, 128                           ' clock prescaler
        Out Clkpr , R16                        ' doc2535, T13, Seite 28
        ldi r16, 0                             ' clock = clock / 1
        Out Clkpr , R16                        ' (T13=9,6MHz)
        nop                                    ' wait
        nop
        nop
        nop
        ldi r16,255                            ' 1Cy, R16 = 255 = SRG-Startwert
        Out Ddrb , R16                         ' 1Cy, PortB auf Ausgang
Main:
        Out Portb , R16                        ' 1Cy, Ausgabe
        mov r24,r16                            ' 1Cy, R24 <= R16, nur Bit0 von Interresse

        ror r18                                ' 1Cy, 23-16 nach rechts, Carry -> Bit23, Bit16 in Carry
        ror r17                                ' 1Cy, 15-8 nach rechts, Carry -> Bit15, Bit8 in Carry
        ror r16                                ' 1Cy, 7-0 nach rechts, Carry -> Bit7, Bit0 in Carry

        eor r24,r16                            ' 1Cy, temp EXOR R16, hier interessieren nur die rechten Bit0
        ror r24                                ' 1Cy, Bit0 in Carry schieben

        brbs 0,eins                            ' 1,5Cy, wenn Carry=1 springe
        andi r18,31                            ' 1Cy, 0 ins Bit 21 schreiben 000xxxxx
        rjmp Main                              ' 2Cy, nchster Schiebetakt

Eins:                                          ' hier landen wir nur , wenn Carry=1 war
        ori r18,32                             ' 1Cy, 1 ins Bit 21 schreiben xx1xxxxx
        rjmp Main                              ' 2Cy, nchster Schiebetakt
$end Asm                                       ' =11,5Cyclen pro Durchlauf

'End